{$APPTYPE CONSOLE}
{$R+}
uses
  Math;

type
  TColor = record r, g, b: integer; end;

procedure CheckDistinct(const a, b: TColor; i, d: integer);
begin
  if (Abs(a.r - b.r) >= d) and (Abs(a.g - b.g) >= d) and (Abs(a.b - b.b) >= d) then
    Exit;
  Write('Color ', i + 1, ' is not distinct from (', a.r, ',', a.g, ',', a.b, ')');
  Halt(1);
end;

var
  fin, fout, fans: TextFile;
  cin, cout: array of TColor;
  i, j, N, K, D: integer;
begin
  AssignFile(fin, ParamStr(1)); Reset(fin);
  Read(fin, N, K, D);
  SetLength(cin, N);
  for i := 0 to N - 1 do with cin[i] do Read(fin, r, g, b);
  CloseFile(fin);
  SetLength(cout, K);
  try
     AssignFile(fout, ParamStr(2)); Reset(fout);
     Read(fout, cout[0].r);
     if cout[0].r = -1 then begin
       AssignFile(fans, ParamStr(3)); Reset(fans);
       Read(fans, i);
       CloseFile(fans);
       if i = -1 then Halt(0);
       Writeln('-1 when solution exists');
       Halt(1);
     end;
     Read(fout, cout[0].g, cout[0].b);
     for i := 1 to K - 1 do with cout[i] do Read(fout, r, g, b);
     for i := 0 to K - 1 do begin
       with cout[i] do
         if not InRange(r, 0, 255) or not InRange(g, 0, 255) or not InRange(b, 0, 255) then begin
           Writeln('Component not in range at color ', i + 1);
           Halt(2);
         end;
       for j := 0 to N - 1 do CheckDistinct(cin[j], cout[i], i, D);
       for j := 0 to i - 1 do CheckDistinct(cout[j], cout[i], i, D);
     end;
  except
    Halt(2);
  end;
end.